#include <stdio.h>
#include <string.h>

#include "images.h"
#include "utils.h"

static IConv converter("UTF-8", "CP437");

void display_line(const char *line) {
  char input[1024];
  char output[1024];

  strcpy(input, line);
  converter.convert(input, output, sizeof(output));
  printf("%s\n", output);
}

#define SHOW_IMAGE(img)                                                        \
  size = (sizeof(img) / sizeof(char *));                                       \
  for (x = 0; x < size; x++)                                                   \
    display_line(img[x]);                                                      \
  paws();

void paws(void) {
  fflush(stdout);
  getchar();
  printf("\n\n");
}

int main() {
  int x;
  int size;

  SHOW_IMAGE(skull);
  SHOW_IMAGE(skullblink);
  SHOW_IMAGE(icu);

  SHOW_IMAGE(ghead);
  SHOW_IMAGE(ghost);
  SHOW_IMAGE(wolf);
  SHOW_IMAGE(panther);
  SHOW_IMAGE(bat);

  return 0;
}
